/* ./sym/PswWindowOps.c generated from PswWindowOps.psw
   by unix pswrap V1.009  Wed Apr 19 17:50:24 PDT 1989
 */

#include <dpsclient/dpsfriends.h>
#include <string.h>

#line 1 "PswWindowOps.psw"
/*
 * Winfo
 * by Paul S. Kleppner
 *
 * This program may be freely distributed, but not sold.
 * It is provided without warranty of any kind, expressed or
 * implied, as to its fitness for any particular use.
 */

/*
 * This file contains DPS wrappers for a number of
 * functions which deal with windows.  We have to write our
 * own wrappers because we are dealing with true DPS window numbers
 * as known by the window server.  The appkit, and the standard wrappers,
 * seem to use "logical" window numbers which are local to each app.
 */

///////////////////////////////////////////////////////////////////////////////
// PswFindWindow    	    	    	    	    	    	    	     //
//  	Look up the window at the  given  location;  returns its number, and //
// whether or not one was found.    	    	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 32 "./sym/PswWindowOps.c"
void PswFindWindow(float x, float y, int initWin, float *lx, float *ly, int *winFound, int *didFind)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjReal obj0;
    DPSBinObjReal obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjGeneric obj14;
    DPSBinObjGeneric obj15;
    DPSBinObjGeneric obj16;
    char obj17[10];
    char obj18[5];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 17, 155,
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, 5, 146},	/* Above */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: initWin */
    {DPS_EXEC|DPS_NAME, 0, 10, 136},	/* findwindow */
    {DPS_LITERAL|DPS_INT, 0, 0, 3},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 2},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 4},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'f','i','n','d','w','i','n','d','o','w'},
    {'A','b','o','v','e'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  DPSResultsRec _dpsR[4];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tFloat, -1 },
    { dps_tFloat, -1 },
    { dps_tInt, -1 },
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)lx;
    _dpsR[1] = _dpsRstat[1];
    _dpsR[1].value = (char *)ly;
    _dpsR[2] = _dpsRstat[2];
    _dpsR[2].value = (char *)winFound;
    _dpsR[3] = _dpsRstat[3];
    _dpsR[3].value = (char *)didFind;

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.realVal = x;
  _dpsP[1].val.realVal = y;
  _dpsP[3].val.integerVal = initWin;
  DPSSetResultTable(_dpsCurCtxt, _dpsR, 4);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,155);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 27 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswCurrentWindowAlpha    	    	    	    	    	    	     //
//  	Return alpha value for current window. 	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 119 "./sym/PswWindowOps.c"
void PswCurrentWindowAlpha(int win, int *alpha)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    char obj8[18];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 8, 86,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 18, 64},	/* currentwindowalpha */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'c','u','r','r','e','n','t','w','i','n','d','o','w','a','l','p','h','a'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  DPSResultsRec _dpsR[1];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)alpha;

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = win;
  DPSSetResultTable(_dpsCurCtxt, _dpsR, 1);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,86);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 35 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswCurrentWindowBounds   	    	    	    	    	    	     //
//  	Return bounds of current window.    	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 175 "./sym/PswWindowOps.c"
void PswCurrentWindowBounds(int win, float *x, float *y, float *w, float *h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    char obj14[19];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 14, 135,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 19, 112},	/* currentwindowbounds */
    {DPS_LITERAL|DPS_INT, 0, 0, 3},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 2},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 4},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'c','u','r','r','e','n','t','w','i','n','d','o','w','b','o','u','n','d','s'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  DPSResultsRec _dpsR[4];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tFloat, -1 },
    { dps_tFloat, -1 },
    { dps_tFloat, -1 },
    { dps_tFloat, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)x;
    _dpsR[1] = _dpsRstat[1];
    _dpsR[1].value = (char *)y;
    _dpsR[2] = _dpsRstat[2];
    _dpsR[2].value = (char *)w;
    _dpsR[3] = _dpsRstat[3];
    _dpsR[3].value = (char *)h;

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = win;
  DPSSetResultTable(_dpsCurCtxt, _dpsR, 4);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,135);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 44 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswCurrentWindowDepth    	    	    	    	    	    	     //
//  	Return depth of current window.      	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 252 "./sym/PswWindowOps.c"
void PswCurrentWindowDepth(int win, int *depth)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    char obj8[18];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 8, 86,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 18, 64},	/* currentwindowdepth */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'c','u','r','r','e','n','t','w','i','n','d','o','w','d','e','p','t','h'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  DPSResultsRec _dpsR[1];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)depth;

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = win;
  DPSSetResultTable(_dpsCurCtxt, _dpsR, 1);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,86);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 52 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswCurrentOwner  	    	    	    	    	    	    	     //
//  	Returns owner (i.e. context value) for current window	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 308 "./sym/PswWindowOps.c"
void PswCurrentOwner(int win, int *context)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    char obj8[12];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 8, 80,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 12, 64},	/* currentowner */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'c','u','r','r','e','n','t','o','w','n','e','r'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  DPSResultsRec _dpsR[1];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)context;

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = win;
  DPSSetResultTable(_dpsCurCtxt, _dpsR, 1);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,80);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 60 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswMoveWindow    	    	    	    	    	    	    	     //
//  	Move the lower left corner to the specified screen coordinates.  The //
// absolute value of X and Y must be less than 16000.	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 365 "./sym/PswWindowOps.c"
void PswMoveWindow(int win, float x, float y)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjReal obj0;
    DPSBinObjReal obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    char obj4[10];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 4, 46,
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 10, 32},	/* movewindow */
    {'m','o','v','e','w','i','n','d','o','w'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[2].val.integerVal = win;
  _dpsP[0].val.realVal = x;
  _dpsP[1].val.realVal = y;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,46);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 69 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswPlaceWindow
///////////////////////////////////////////////////////////////////////////////
#line 405 "./sym/PswWindowOps.c"
void PswPlaceWindow(int win, float x, float y, float w, float h)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjReal obj0;
    DPSBinObjReal obj1;
    DPSBinObjReal obj2;
    DPSBinObjReal obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    char obj6[11];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 6, 63,
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: h */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 11, 48},	/* placewindow */
    {'p','l','a','c','e','w','i','n','d','o','w'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[4].val.integerVal = win;
  _dpsP[0].val.realVal = x;
  _dpsP[1].val.realVal = y;
  _dpsP[2].val.realVal = w;
  _dpsP[3].val.realVal = h;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,63);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 76 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswSetCurrentWindowLevel 	    	    	    	    	    	     //
//  	Sets level of current window.	    	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 452 "./sym/PswWindowOps.c"
void PswSetCurrentWindowLevel(int level)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    char obj3[14];
    char obj4[13];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 3, 55,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: level */
    {DPS_EXEC|DPS_NAME, 0, 13, 38},	/* currentwindow */
    {DPS_EXEC|DPS_NAME, 0, 14, 24},	/* setwindowlevel */
    {'s','e','t','w','i','n','d','o','w','l','e','v','e','l'},
    {'c','u','r','r','e','n','t','w','i','n','d','o','w'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = level;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,55);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 84 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswCurrentWindowLevel    	    	    	    	    	    	     //
//  	Returns level of current window.    	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 491 "./sym/PswWindowOps.c"
void PswCurrentWindowLevel(int win, int *level)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    char obj8[18];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 8, 86,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 18, 64},	/* currentwindowlevel */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'c','u','r','r','e','n','t','w','i','n','d','o','w','l','e','v','e','l'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  DPSResultsRec _dpsR[1];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)level;

  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = win;
  DPSSetResultTable(_dpsCurCtxt, _dpsR, 1);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,86);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 92 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswOrderWindow   	    	    	    	    	    	    	     //
//  	Orders given window on the screen list.	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 547 "./sym/PswWindowOps.c"
void PswOrderWindow(int place, int otherwin, int win)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    char obj4[11];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 4, 47,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: place */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: otherwin */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 11, 32},	/* orderwindow */
    {'o','r','d','e','r','w','i','n','d','o','w'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[0].val.integerVal = place;
  _dpsP[1].val.integerVal = otherwin;
  _dpsP[2].val.integerVal = win;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,47);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 100 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswSetOwner	    	    	    	    	    	    	    	     //
//  	Changes the windows owning DPS context.	    	    	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 588 "./sym/PswWindowOps.c"
void PswSetOwner(int win, int context)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    char obj3[8];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 3, 36,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: context */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: win */
    {DPS_EXEC|DPS_NAME, 0, 8, 24},	/* setowner */
    {'s','e','t','o','w','n','e','r'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[1].val.integerVal = win;
  _dpsP[0].val.integerVal = context;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,36);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 108 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswFillBelowWin  	    	    	    	    	    	    	     //
//  	Fills window w2 with contents of all windows below level of w1.	     //
///////////////////////////////////////////////////////////////////////////////
#line 626 "./sym/PswWindowOps.c"
void PswFillBelowWin(int w1, int w2)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    char obj4[10];
    char obj5[5];
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 4, 51,
    {DPS_EXEC|DPS_NAME, 0, 5, 42},	/* Below */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w1 */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w2 */
    {DPS_EXEC|DPS_NAME, 0, 10, 32},	/* fillwindow */
    {'f','i','l','l','w','i','n','d','o','w'},
    {'B','e','l','o','w'},
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[1].val.integerVal = w1;
  _dpsP[2].val.integerVal = w2;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,51);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 116 "PswWindowOps.psw"


///////////////////////////////////////////////////////////////////////////////
// PswWhatsAbove    	    	    	    	    	    	    	     //
// PswWhatsBelow    	    	    	    	    	    	    	     //
//  	Tells me what the hell Above and Below equate to.   	    	     //
///////////////////////////////////////////////////////////////////////////////
#line 669 "./sym/PswWindowOps.c"
void PswWhatsAbove(int *value)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    char obj7[5];
    } _dpsQ;
  static const _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 7, 65,
    {DPS_EXEC|DPS_NAME, 0, 5, 56},	/* Above */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'A','b','o','v','e'},
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  DPSResultsRec _dpsR[1];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)value;

  DPSSetResultTable(_dpsCurCtxt, _dpsR, 1);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,65);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 125 "PswWindowOps.psw"

#line 713 "./sym/PswWindowOps.c"
void PswWhatsBelow(int *value)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    char obj7[5];
    } _dpsQ;
  static const _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 7, 65,
    {DPS_EXEC|DPS_NAME, 0, 5, 56},	/* Below */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 119},	/* printobject */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 70},	/* flush */
    {'B','e','l','o','w'},
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  DPSResultsRec _dpsR[1];
  static const DPSResultsRec _dpsRstat[] = {
    { dps_tInt, -1 },
    };
    _dpsR[0] = _dpsRstat[0];
    _dpsR[0].value = (char *)value;

  DPSSetResultTable(_dpsCurCtxt, _dpsR, 1);
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,65);
  DPSAwaitReturnValues(_dpsCurCtxt);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 128 "PswWindowOps.psw"



/* 
	Wrap added by John Hrnkvist to draw a nice NXBezel-look alike without
	filling the interior.
*/
#line 763 "./sym/PswWindowOps.c"
void drawBezel(float x, float y, float width, float height)
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjReal obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjReal obj6;
    DPSBinObjReal obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjReal obj9;
    DPSBinObjReal obj10;
    DPSBinObjReal obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjReal obj14;
    DPSBinObjReal obj15;
    DPSBinObjGeneric obj16;
    DPSBinObjReal obj17;
    DPSBinObjReal obj18;
    DPSBinObjGeneric obj19;
    DPSBinObjGeneric obj20;
    DPSBinObjGeneric obj21;
    DPSBinObjGeneric obj22;
    DPSBinObjGeneric obj23;
    DPSBinObjGeneric obj24;
    DPSBinObjGeneric obj25;
    DPSBinObjReal obj26;
    DPSBinObjReal obj27;
    DPSBinObjGeneric obj28;
    DPSBinObjReal obj29;
    DPSBinObjReal obj30;
    DPSBinObjGeneric obj31;
    DPSBinObjGeneric obj32;
    DPSBinObjReal obj33;
    DPSBinObjReal obj34;
    DPSBinObjGeneric obj35;
    DPSBinObjReal obj36;
    DPSBinObjGeneric obj37;
    DPSBinObjReal obj38;
    DPSBinObjReal obj39;
    DPSBinObjGeneric obj40;
    DPSBinObjGeneric obj41;
    } _dpsQ;
  static const _dpsQ _dpsStat = {
    DPS_DEF_TOKENTYPE, 42, 340,
    {DPS_LITERAL|DPS_REAL, 0, 0, 2.0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 155},	/* setlinewidth */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 157},	/* setrgbcolor */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 107},	/* moveto */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: height */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: width */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: height */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 167},	/* stroke */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 157},	/* setrgbcolor */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: width */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: height */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 107},	/* moveto */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: width */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 99},	/* lineto */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 167},	/* stroke */
    }; /* _dpsQ */
  _dpsQ _dpsF;	/* local copy  */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  _dpsF = _dpsStat;	/* assign automatic variable */

  _dpsP[6].val.realVal =
  _dpsP[9].val.realVal =
  _dpsP[14].val.realVal =
  _dpsP[26].val.realVal =
  _dpsP[33].val.realVal =
  _dpsP[38].val.realVal = x;
  _dpsP[7].val.realVal =
  _dpsP[10].val.realVal =
  _dpsP[17].val.realVal =
  _dpsP[29].val.realVal =
  _dpsP[36].val.realVal =
  _dpsP[39].val.realVal = y;
  _dpsP[15].val.realVal =
  _dpsP[27].val.realVal =
  _dpsP[34].val.realVal = width;
  _dpsP[11].val.realVal =
  _dpsP[18].val.realVal =
  _dpsP[30].val.realVal = height;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,340);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 148 "PswWindowOps.psw"


